Bug 1605156 - Review Request: python-bundled-wheels - Wheels to be bundled with Python tools for virtual environments
Summary: Review Request: python-bundled-wheels - Wheels to be bundled with Python tool...
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-07-20 10:09 UTC by Miro Hrončok
Modified: 2018-08-08 09:53 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-08-08 09:53:23 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Miro Hrončok 2018-07-20 10:09:09 UTC
Spec URL: https://churchyard.fedorapeople.org/SRPMS/python-bundled-wheels.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/python-bundled-wheels-0-1.fc28.src.rpm
Description:
The purpose of this package is to build various Python wheels to be bundled
with Python tools for virtual environments, instead of taking prebuilt bundled
wheels from upstreams. This also allows to deduplicate the wheels and specify
the licenses better (no need to specify them in the projects that need those).

Fedora Account System Username: churchyard

Rationale: We bundle a lot of wheels in Fedora and we don't even rebuild them. This is an attempt to fix it. Maybe even to replace the python3 rewheel patch in  the future. Consider it proof of concept. Feedback is welcomed.

In the package that has wheel, one would do:

    Requires: wheel(setuptools-39.1.0-py2.py3-none-any.whl)
    
    ...
    
    pushd %{buildroot}%{python3_sitelib}/virtualenv_support
    rm setuptools-39.1.0-py2.py3-none-any.whl
    ln -s %{_datatdir}/python-bundled-wheels/setuptools-39.1.0-py2.py3-none-any.whl .
    ...
    popd

If desired, we could provide a macro for %{_datatdir}/python-bundled-wheels and possible for the linking, so the maintainer would only need to: require the wheel and run:

    for WHL in %{buildroot}%{python3_sitelib}/virtualenv_support/*; do
       %link_bundled_wheel $WHL
    done

(This is just an idea and it is not done yet.)

Comment 1 Miro Hrončok 2018-07-20 10:10:34 UTC
The dependency could even be autogenereated ;)

Comment 2 Robert-André Mauchin 2018-07-21 21:25:54 UTC
Package approved.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* LGPL (v2.1 or later)",
     "Unknown or generated", "*No copyright* PSF", "MIT/X11 (BSD like)",
     "BSD (unspecified)", "PSF (v2 or later)", "*No copyright* BSD
     (unspecified)", "ISC", "LGPL (v2.1 or later)", "Apache (v2.0) BSD
     (unspecified)", "*No copyright* Apache (v2.0)". 1813 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/python-bundled-wheels/review-python-
     bundled-wheels/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in python-
     bundled-wheels-filesystem , python-bundled-wheels-setuptools-21.2.1 ,
     python-bundled-wheels-setuptools-28.8.0 , python-bundled-wheels-
     setuptools-36.8.0 , python-bundled-wheels-setuptools-39.0.1 , python-
     bundled-wheels-setuptools-39.1.0 , python-bundled-wheels-pip-8.1.2 ,
     python-bundled-wheels-pip-9.0.1 , python-bundled-wheels-pip-9.0.3 ,
     python-bundled-wheels-pip-10.0.1 , python-bundled-wheels-wheel-0.29.0
     , python-bundled-wheels-wheel-0.31.1 , python-bundled-wheels-
     argparse-1.4.0
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-bundled-wheels-filesystem-0-1.fc29.noarch.rpm
          python-bundled-wheels-setuptools-21.2.1-21.2.1-1.fc29.noarch.rpm
          python-bundled-wheels-setuptools-28.8.0-28.8.0-1.fc29.noarch.rpm
          python-bundled-wheels-setuptools-36.8.0-36.8.0-1.fc29.noarch.rpm
          python-bundled-wheels-setuptools-39.0.1-39.0.1-1.fc29.noarch.rpm
          python-bundled-wheels-setuptools-39.1.0-39.1.0-1.fc29.noarch.rpm
          python-bundled-wheels-pip-8.1.2-8.1.2-1.fc29.noarch.rpm
          python-bundled-wheels-pip-9.0.1-9.0.1-1.fc29.noarch.rpm
          python-bundled-wheels-pip-9.0.3-9.0.3-1.fc29.noarch.rpm
          python-bundled-wheels-pip-10.0.1-10.0.1-1.fc29.noarch.rpm
          python-bundled-wheels-wheel-0.29.0-0.29.0-1.fc29.noarch.rpm
          python-bundled-wheels-wheel-0.31.1-0.31.1-1.fc29.noarch.rpm
          python-bundled-wheels-argparse-1.4.0-1.4.0-1.fc29.noarch.rpm
          python-bundled-wheels-0-1.fc29.src.rpm
python-bundled-wheels-filesystem.noarch: W: no-documentation
python-bundled-wheels-setuptools-21.2.1.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-setuptools-21.2.1.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-setuptools-21.2.1.noarch: W: no-documentation
python-bundled-wheels-setuptools-28.8.0.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-setuptools-28.8.0.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-setuptools-28.8.0.noarch: W: no-documentation
python-bundled-wheels-setuptools-36.8.0.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-setuptools-36.8.0.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-setuptools-36.8.0.noarch: W: no-documentation
python-bundled-wheels-setuptools-39.0.1.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-setuptools-39.0.1.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-setuptools-39.0.1.noarch: W: no-documentation
python-bundled-wheels-setuptools-39.1.0.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-setuptools-39.1.0.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-setuptools-39.1.0.noarch: W: no-documentation
python-bundled-wheels-pip-8.1.2.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-pip-8.1.2.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-pip-8.1.2.noarch: W: no-documentation
python-bundled-wheels-pip-9.0.1.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-pip-9.0.1.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-pip-9.0.1.noarch: W: no-documentation
python-bundled-wheels-pip-9.0.3.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-pip-9.0.3.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-pip-9.0.3.noarch: W: no-documentation
python-bundled-wheels-pip-10.0.1.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-pip-10.0.1.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-pip-10.0.1.noarch: W: no-documentation
python-bundled-wheels-wheel-0.29.0.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-wheel-0.29.0.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-wheel-0.29.0.noarch: W: no-documentation
python-bundled-wheels-wheel-0.31.1.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-wheel-0.31.1.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-wheel-0.31.1.noarch: W: no-documentation
python-bundled-wheels-argparse-1.4.0.noarch: W: spelling-error Summary(en_US) whl -> who, why, whirl
python-bundled-wheels-argparse-1.4.0.noarch: W: spelling-error %description -l en_US whl -> who, why, whirl
python-bundled-wheels-argparse-1.4.0.noarch: W: no-documentation
python-bundled-wheels.src: W: spelling-error %description -l en_US prebuilt -> rebuilt, p rebuilt, rebuild
python-bundled-wheels.src: W: spelling-error %description -l en_US upstreams -> upstream, up streams, up-streams
python-bundled-wheels.src: W: spelling-error %description -l en_US deduplicate -> reduplicate, duplicate, complicated
14 packages and 0 specfiles checked; 0 errors, 40 warnings.

Comment 4 Miro Hrončok 2018-08-08 09:53:23 UTC
OK, we'll do it differently, thanks for the review anyway.

https://lists.fedoraproject.org/archives/list/python-devel@lists.fedoraproject.org/message/JA2GU7GILK4FYS5CAMOTPRCNJCAFDNRQ/


Note You need to log in before you can comment on or make changes to this bug.